package ru.dbotthepony.mc.otm.container

import net.minecraft.world.item.Item
import net.minecraft.world.item.ItemStack
import net.minecraft.world.item.Items

interface IFilteredContainerSlot : IContainerSlot {
	var filter: Item?

	val isForbiddenForAutomation: Boolean get() {
		return filter === Items.AIR
	}

	val hasFilter: Boolean
		get() = filter != null

	fun testSlotFilter(itemStack: ItemStack): Boolean {
		return testSlotFilter(itemStack.item)
	}

	fun testSlotFilter(item: Item): Boolean {
		if (filter == null) {
			return true
		} else {
			return filter === item
		}
	}

	@Deprecated("Dummy implementation")
	class Dummy(parent: IContainerSlot) : IFilteredContainerSlot, IContainerSlot by parent {
		override var filter: Item?
			get() = null
			set(value) {}
	}
}
